unit Unit1;

interface

uses
	Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
	StdCtrls, ComCtrls;

type
	TForm1 = class(TForm)
		goBTN : TButton;
		Memo1 : TMemo;
    TrackBar1: TTrackBar;
    TrackBar2: TTrackBar;
    Label1: TLabel;
    Label2: TLabel;
		procedure goBTNClick(Sender : TObject);
		procedure FormClose(Sender : TObject; var Action : TCloseAction);
		procedure TrackBar1Change(Sender : TObject);
    procedure TrackBar2Change(Sender: TObject);
    procedure FormCreate(Sender: TObject);
	private
		{ Private declarations }
	public
		{ Public declarations }
	end;

var
	Form1       : TForm1;
	fName       : AnsiString;
	Done        : Boolean;
	DeviceIndex : LongWord;

implementation

uses
	AIOUSB;

const
	EOM    = $8000;
	EOF    = $4000;
	EOP    = $2000;
	LOOP   = $1000;
	SWITCH = EOM or EOF or LOOP;

{$R *.DFM}

type
	Tdataframe = array [0 .. 4095] of Word;

procedure PopulateFrame(var frame : Tdataframe; data : Word);
var
	i : integer;
begin
	for i := 0 to high(frame) do frame[i] := data;
end;

procedure open;
begin
	// Result := GenericVendorWrite(DeviceIndex, AUR_DAC_CONTROL, $80, 0, 0, nil); //Reset
	// if Result <> ERROR_SUCCESS then Exit;
	//
	// Result := GenericVendorWrite(DeviceIndex, AUR_DAC_DATAPTR, $00, 0, 0, nil); //DataPtr << 0
	// if Result <> ERROR_SUCCESS then Exit;
	//
	// CtrDivisor := Round(12000000 / ClockHz);
	// ClockHz := 12000000 / CtrDivisor;
	//
	// Result := GenericVendorWrite(DeviceIndex, AUR_DAC_DIVISOR, 0, CtrDivisor, 0, nil); //Set divisor
	// if Result <> ERROR_SUCCESS then Exit;

end;

procedure TForm1.FormCreate(Sender: TObject);
begin
	TrackBar1.OnChange(nil);
    TrackBar2.OnChange(nil);
end;

procedure TForm1.goBTNClick(Sender : TObject);
var
	FrameData   : Tdataframe;
	i           : integer;
	FramePoints : DWORD;
	Status      : LongWord;
	Clock  : Double;
begin
	DeviceIndex := AIOUSB.diOnly;

	Done := false;
	Clock := 50000.0;

	Status := AIOUSB.DACOutputCloseNoEnd(DeviceIndex, false);
	if Status <> ERROR_SUCCESS then Memo1.lines.Add('DACOutputClose: ' + IntToStr(Status));

	Status := AIOUSB.DACOutputOpen(DeviceIndex, Clock); // 50kHz playback
	if Status <> ERROR_SUCCESS then Memo1.lines.Add('DACOutputOpen: ' + IntToStr(Status));

	Status := AIOUSB.DACOutputSetCount(DeviceIndex, 1); // on one DAC only
	if Status <> ERROR_SUCCESS then Memo1.lines.Add('DACOutputSetCount: ' + IntToStr(Status));

	FramePoints := Length(FrameData);
// write an entire SRAM worth
	for i := 0 to 15 do
	begin
		PopulateFrame(FrameData, $0800 or EOP or (i shl 7));
	   	if i = trackbar1.Position then FrameData[4095] := (FrameData[4095] and $0FFF) or SWITCH;

		repeat
			Status := AIOUSB.DACOutputFrameRaw(DeviceIndex, FramePoints, @FrameData[0]);
			if Status <> ERROR_SUCCESS then Memo1.lines.Add('DACOutputFrameRaw 1: ' + IntToStr(Status));
		until Status <> ERROR_NOT_READY;

	end;
// write the entire second SRAM worth
	for i := 0 to 15 do
	begin
		PopulateFrame(FrameData, $0000 or EOP or (i shl 7));
	    if i = trackbar2.Position then FrameData[4095] := (FrameData[4095] and $0FFF) or SWITCH;

		repeat
			Status := AIOUSB.DACOutputFrameRaw(DeviceIndex, FramePoints, @FrameData[0]);
			if Status <> ERROR_SUCCESS then Memo1.lines.Add('DACOutputFrameRaw 2: ' + IntToStr(Status));
		until Status <> ERROR_NOT_READY;

		if i = 15 then Status := AIOUSB.DACOutputStart(DeviceIndex);
		if Status <> ERROR_SUCCESS then Memo1.lines.Add('DACOutputStart: ' + IntToStr(Status));
	end;
end;

procedure TForm1.FormClose(Sender : TObject; var Action : TCloseAction);
begin
	Done := true;
end;

procedure TForm1.TrackBar1Change(Sender : TObject);
begin
    Label1.Caption := 'Last sample of frame '+trackbar1.Position.ToString + ' will have 1101 "switch SRAM" masked in';
end;

procedure TForm1.TrackBar2Change(Sender: TObject);
begin
    Label2.Caption := 'Last sample of frame '+trackbar2.Position.ToString + ' will have 1101 "switch SRAM" masked in';
end;

end.
